clear
squeezerm
w=2*pi*logspace(0,6);
y = logspace(0,6,1e5);
f= w/(2*pi);
eval('parameters')

%find transfer functions from noise sources to phase of sqzing

phiPSL_io(1)=linio('squeezerm/phi PSL', 1, 'in');  %Phase noise PSL
phiPSL_io(2)=linio('squeezerm/Sum18', 1, 'out'); %relative phase between AS port and sqz
phiPSL_lin= linearize('squeezerm', phiPSL_io);

FiberNoise_io(1)=linio('squeezerm/fibernoise', 1, 'in');  %fiber noise
FiberNoise_io(2)=linio('squeezerm/Sum18', 1, 'out'); %relative phase between AS port and sqz
FiberNoise_lin= linearize('squeezerm', FiberNoise_io);

phiMain_io(1)=linio('squeezerm/phi 0', 1, 'in'); %path length phase noise Main laser
phiMain_io(2)=linio('squeezerm/Sum18', 1, 'out'); %relative phase between AS port and sqz
phiMain_lin= linearize('squeezerm', phiMain_io);

phiAux_io(1)= linio('squeezerm/phi1', 1, 'in');     %path length phase noise Aux laser
phiAux_io(2)=linio('squeezerm/Sum18', 1, 'out'); %relative phase between AS port and sqz
phiAux_lin= linearize('squeezerm', phiAux_io);

phiGreen_io(1)= linio('squeezerm/phi2', 1, 'in');     %path length phase noise Green
phiGreen_io(2)=linio('squeezerm/Sum18', 1, 'out'); %relative phase between AS port and sqz
phiGreen_lin= linearize('squeezerm', phiGreen_io);

phiLO_io(1)= linio('squeezerm/phiLO', 1, 'in');     %path length phase noise local oscilator
phiLO_io(2)=linio('squeezerm/Sum18', 1, 'out'); %relative phase between AS port and sqz
phiLO_lin= linearize('squeezerm', phiLO_io);

phi0n_io(1)=linio('squeezerm/phi 0n', 1, 'in');     %laser phase noise
phi0n_io(2)=linio('squeezerm/Sum18', 1, 'out'); %relative phase between AS port and sqz
phi0n_lin= linearize('squeezerm', phi0n_io);

phiAuxn_io(1)= linio('squeezerm/phi1n', 1, 'in');   %laser phase noise
phiAuxn_io(2)=linio('squeezerm/Sum18', 1, 'out'); %relative phase between AS port and sqz
phiAuxn_lin= linearize('squeezerm', phiAuxn_io);

LSHG_io(1)= linio('squeezerm/L SHG', 1, 'in');
LSHG_io(2)=linio('squeezerm/Sum18', 1, 'out'); %relative phase between AS port and sqz
LSHG_lin = linearize('squeezerm', LSHG_io);

LOPO_io(1)= linio('squeezerm/L OPO', 1, 'in');
LOPO_io(2)=linio('squeezerm/Sum18', 1, 'out'); %relative phase between AS port and sqz
LOPO_lin= linearize('squeezerm', LOPO_io);

AmpGreen_io(1)= linio('squeezerm/Amp Green', 1, 'in');
AmpGreen_io(2)= linio('squeezerm/Sum18', 1, 'out'); %relative phase between AS port and sqz
AmpGreen_lin = linearize('squeezerm', AmpGreen_io);

AmpAux_io(1)= linio('squeezerm/Amp Aux', 1, 'in');
AmpAux_io(2)= linio('squeezerm/Sum18', 1, 'out');
AmpAux_lin= linearize('squeezerm', AmpAux_io);



P1=bodeoptions;
P1.PhaseVisible = 'off';
P1.FreqUnits = 'Hz';
P1.Grid ='on';
P1.InputVisible = {'off'};
P1.OutputVisible = {'off'};

figure
bodemag(phiPSL_lin, phi0n_lin, phiAuxn_lin, AmpAux_lin, AmpGreen_lin,w)
legend('Phase noise on PSL','Phase noise main laser', 'Phase noise on aux laser',  'Amplitude noise of aux','Amplitude noise of green pump', 'Location', 'SouthEast')
title('Laser noise transfer functions')

figure
bodemag(FiberNoise_lin,'r', phiMain_lin, 'b',phiAux_lin, 'g', phiLO_lin,'k', phiGreen_lin, 'm',w);
title('Path length fluctuation transfer functions')
legend( 'Fiber Noise','Path length main laser','Path length aux','Path length LO', 'Path length green','Location', 'SouthEast')

figure
p3 = bodeoptions;
p3.MagUnits = 'abs';
p3.MagScale = 'log';
p3.FreqUnits = 'Hz';
p3.Grid = 'on';
bodemag(LOPO_lin, LSHG_lin, w, p3)
legend('L_{OPO}', 'L_{SHG}', 'Location', 'SouthEast')
title('Cavity length transfer functions')
ylabel('rad/m')

%loglog(y, bodeevalfr(LSHG_lin, y))

%%noise spectra-

phiPSL_spec = spectrum('parameters', 'PSLphi');          %stabilized laser phase noise
[mag_phiPSL_spec, phase_phiPSL]=bode(phiPSL_spec,w);

phi0n_spec = spectrum('parameters', 'FRphi');       %free running laser phase noise
[mag_phi0n_spec, phase_phi0n_spec]=bode(phi0n_spec,w);

phiPL_spec = spectrum('parameters', 'PLtoPhi');          %pathlength to phase noise spectrum
[mag_phiPL_spec, phase_phiPL_spec]=bode(phiPL_spec,w);

CavLength_spec = spectrum('parameters', 'CavLength');   %spectrum of cavity length fluct
[mag_CavLength_spec, phase_CavLength_spec]= bode(CavLength_spec,w);

Intensity_spec = spectrum('parameters', 'Intensity');  %Intensity noise
[mag_Intensity_spec, phase_Intensity_spec]=bode(Intensity_spec, w);

Fiber_spec = spectrum('parameters', 'FiberNoise');
[mag_Fiber_spec, phase_Fiber_spec]= bode(Fiber_spec, w);  %fiber noise

figure
loglog(f, mag_phiPSL_spec(:), f, mag_phi0n_spec(:), f, mag_phiPL_spec(:), f, mag_Intensity_spec(:), f, mag_Fiber_spec(:))
legend('PSL phase noise', 'main and aux lasers phase noise', 'path lengths','Intensity Noise', 'Fiber Noise')
xlabel('Hz')
ylabel('rad/\surd Hz')
title('Spectra of Noise Sources')
grid on

%Spectra of noise on phi SQZ from each source-

phiPSL_noise = phiPSL_spec*phiPSL_lin;        %PSL noise to phi sqz
[mag_phiPSL_noise, phase_phiPSL_noise]= bode(phiPSL_noise, w);

FiberNoise_noise = phi0n_spec*FiberNoise_lin;  %fiber noise
[mag_FiberNoise_noise, phase_FiberNoise_noise] = bode(FiberNoise_noise,w);

phi0n_noise=phi0n_spec*phi0n_lin;     %main laser phase noise to phi sqz    
[mag_phi0n_noise, phase_phi0n_noise]= bode(phi0n_noise, w);

phi1n_noise = phi0n_spec*phiAuxn_lin;     %aux laser pn to phi sqz
[mag_phi1n_noise, phase_phi1n_noise]=bode(phi1n_noise,w);

phiMain_noise= phiPL_spec*phiMain_lin;                 %noise from Path length in main laser       
[mag_phiMain_noise, phase_phiMain_noise]=bode(phiMain_noise,w);

phiAux_noise = phiPL_spec*phiAux_lin;           %noise from path length in aux
[mag_phiAux_noise, phase_phiAux_noise]= bode(phiAux_noise, w);

phiGreen_noise = phiPL_spec*phiGreen_lin;   %noise from green path length
[mag_phiGreen_noise, phase_phiGreen_noise] = bode(phiGreen_noise, w);

phiLO_noise = phiPL_spec*phiLO_lin;   %noise from LO path length
[mag_phiLO_noise, phase_phiLO_noise] = bode(phiLO_noise, w);

AmpAux_noise = Intensity_spec*AmpAux_lin;       %Intensity Noise on Aux laser
[mag_AmpAux_noise, phase_AmpAux_noise] = bode(AmpAux_noise,w);

AmpGreen_noise = Intensity_spec*AmpGreen_lin;       %Intensity noise on green pump
[mag_AmpGreen_noise, phases_AmpGreen_noise] = bode(AmpGreen_noise, w);

LOPO_noise = CavLength_spec*LOPO_lin;  %OPO length flucts
[mag_LOPO_noise, phase_LOPO_noise]= bode(LOPO_noise, w);

LSHG_noise = CavLength_spec*LSHG_lin;       %SHG length
[mag_LSHG_noise, phase_LSHG_noise] = bode(LSHG_noise,w);


%RMS noise

phiPSL_RMS = (cumtrapz(f,mag_phiPSL_noise(:).^2)).^(.5);

FiberNoise_RMS = (cumtrapz(f,mag_FiberNoise_noise(:).^2)).^(.5);

phi0n_RMS = (cumtrapz(f,mag_phi0n_noise(:).^2)).^(.5);

phi1n_RMS = (cumtrapz(f,mag_phi1n_noise(:).^2)).^(.5);

phiMain_RMS = (cumtrapz(f,mag_phiMain_noise(:).^2)).^(.5);

phiAux_RMS = (cumtrapz(f,mag_phiAux_noise(:).^2)).^(.5);

phiGreen_RMS = (cumtrapz(f,mag_phiGreen_noise(:).^2)).^(.5);

phiLO_RMS = (cumtrapz(f,mag_phiLO_noise(:).^2)).^(.5);

AmpAux_RMS = (cumtrapz(f,mag_AmpAux_noise(:).^2)).^(.5);

AmpGreen_RMS = (cumtrapz(f,mag_AmpGreen_noise(:).^2)).^(.5);

LOPO_RMS = (cumtrapz(f,mag_LOPO_noise(:).^2)).^(.5);

LSHG_RMS = (cumtrapz(f,mag_LSHG_noise(:).^2)).^(.5);


figure
loglog(f, mag_phiPSL_noise(:),'b', f, mag_phi0n_noise(:),'g', f, mag_phi1n_noise(:),'r', f, mag_AmpAux_noise(:),'c', f, mag_AmpGreen_noise(:),'m', f, phiPSL_RMS,':b', f, phi0n_RMS,':g', f, phi1n_RMS, ':r',f, AmpAux_RMS,':c', f, AmpGreen_RMS, ':m')
legend('Phase noise on PSL', 'Phase noise on main laser', 'Phase noise aux laser', 'Amplitude noise on aux laser', 'Amplitude noise of green pump','Location', 'SouthEast')
xlabel('Hz')
ylabel('rad/\surd Hz(rad rms)')
title('Squeezing phase noise from laser noise')
grid on

figure
loglog(f, mag_FiberNoise_noise(:), 'r',f ,mag_phiMain_noise(:),'b', f, mag_phiAux_noise(:),'g', f, mag_phiLO_noise(:), 'k', f, mag_phiGreen_noise(:), 'm',  f, phiLO_RMS, ':k', f, phiGreen_RMS, ':m',f, phiMain_RMS, ':b', f, phiAux_RMS, ':g', f, FiberNoise_RMS, ':r')
legend('Fiber noise','Path length main laser', 'Path length aux laser', 'Path length LO', 'Path length green', 'Location', 'SouthWest')
xlabel('Hz')
ylabel('rad/\surd Hz(rad rms)')
title('Squeezing phase noise from path length fluctuations')
grid on

figure
loglog(f, mag_LOPO_noise(:), 'b',  f, mag_LSHG_noise(:),'g', f, LSHG_RMS,':g',f ,LOPO_RMS, ':b')
legend('L_{OPO}', 'L_{SHG}', 'Location', 'SouthEast')
xlabel('Hz')
ylabel('rad/\surd Hz(rad rms)')
title('Squeezing phase noise from cavity length fluctuations')
grid on